﻿// Dll1.cpp : 定义 DLL 应用程序的导出函数。
//

#include "stdafx.h"


#include "Alg.h"

#ifdef  __cplusplus
extern "C" {
#endif
#include "api.h"
#include "rng.h"
#ifdef  __cplusplus
}
#endif

unsigned long longrand_get_sd_byts() {

	return 48;//bytes of init seed
}

int rand_init(unsigned char * s, unsigned long long s_byts) {

	randombytes_init(s, NULL, 256);
	return 0;
}

int rand_byts(unsigned long long r_byts, unsigned char * r) {

	randombytes(r, r_byts);
	return 0;
}



unsigned long long pke_get_pk_byts() {
	return CRYPTO_PUBLICKEYBYTES;
}

unsigned long long pke_get_sk_byts() {
	return CRYPTO_SECRETKEYBYTES;
}
unsigned long long pke_get_ct_byts() {
	return CRYPTO_CIPHERTEXTBYTES;
}

int pke_keygen(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts) {
	lacpke_keygen(pk, sk);
	*pk_byts = CRYPTO_CIPHERTEXTBYTES;
	*sk_byts = CRYPTO_SECRETKEYBYTES;
	return 0;
}

int pke_enc(unsigned char * pk, unsigned long long pk_byts, unsigned char * m, unsigned long long m_byts, unsigned char * c, unsigned long long * c_byts) {
	lacpke_enc(c, c_byts, m, m_byts, pk);
	return 0;
}

int pke_dec(unsigned char * sk, unsigned long long sk_byts, unsigned char * c, unsigned long long c_byts, unsigned char * m, unsigned long long * m_byts) {
	lacpke_dec(m, m_byts, c, c_byts, sk);
	return 0;
}


unsigned long long kem_get_pk_byts() {
	return CRYPTO_PUBLICKEYBYTES;
}

unsigned long long kem_get_sk_byts() {
	return CRYPTO_SECRETKEYBYTES;
}

unsigned long long kem_get_ss_byts() {
	return CRYPTO_BYTES;
}

unsigned long long kem_get_ct_byts() {
	return CRYPTO_CIPHERTEXTBYTES;
}

int kem_keygen(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts) {
	*pk_byts = CRYPTO_PUBLICKEYBYTES;
	*sk_byts = CRYPTO_SECRETKEYBYTES;
	lackem_keygen(pk, sk);
	return 0;
}

int kem_enc(unsigned char * pk, unsigned long long pk_byts, unsigned char * ss, unsigned long long * ss_byts, unsigned char * ct, unsigned long long * ct_byts) {
	*ss_byts = CRYPTO_BYTES;
	*ct_byts = CRYPTO_CIPHERTEXTBYTES;
	lackem_enc(ct, ss, pk);
	return 0;
}

int kem_dec(unsigned char * sk, unsigned long long sk_byts, unsigned char * ct, unsigned long long ct_byts, unsigned char * ss, unsigned long long * ss_byts) {
	*ss_byts = CRYPTO_BYTES;
	lackem_dec(ss, ct, sk);
	return 0;
}


unsigned long long kex_get_rounds() {
	return 2;
}

unsigned long long kex_get_pk_byts() {
	return CRYPTO_PUBLICKEYBYTES;
}

unsigned long long kex_get_sk_byts() {
	return CRYPTO_SECRETKEYBYTES;
}

unsigned long long kex_get_pa_byts() {
	return CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES + CRYPTO_CIPHERTEXTBYTES + CRYPTO_BYTES + CRYPTO_PUBLICKEYBYTES;
}

unsigned long long kex_get_pb_byts() {
	return CRYPTO_PUBLICKEYBYTES;
}

unsigned long long kex_get_ss_byts() {
	return CRYPTO_BYTES;
}

unsigned long long kex_get_bw_byts() {
	return CRYPTO_CIPHERTEXTBYTES*3+CRYPTO_PUBLICKEYBYTES;
}

int kex_init_a(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts, unsigned char * pa, unsigned long long * pa_byts) {
	//check pointer
	if (pk == NULL || sk == NULL)
	{
		return  -1;
	}
	kex_keygen(pk, sk);
	*pk_byts = CRYPTO_PUBLICKEYBYTES;
	*sk_byts = CRYPTO_SECRETKEYBYTES;
	memcpy(pa, sk, CRYPTO_SECRETKEYBYTES);//pa=sk_a
	*pa_byts = CRYPTO_SECRETKEYBYTES;

	return 0;
}

int kex_init_b(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts, unsigned char * pb, unsigned long long * pb_byts) {
	
	*pk_byts = CRYPTO_PUBLICKEYBYTES;
	*sk_byts = CRYPTO_SECRETKEYBYTES;
	*pb_byts = CRYPTO_SECRETKEYBYTES;
	kex_keygen(pk, sk);
	memcpy(pb, sk, CRYPTO_SECRETKEYBYTES);

	return 0;
}

int kex_send_a(unsigned char * pkb, unsigned long long pkb_byts, unsigned char * pa, unsigned long long * pa_byts, unsigned char * ma, unsigned long long * ma_byts) {
	
	unsigned char pk[CRYPTO_PUBLICKEYBYTES], sk[CRYPTO_SECRETKEYBYTES], c[CRYPTO_CIPHERTEXTBYTES], k1[CRYPTO_BYTES];
	ake_alice_send(pk, sk, pkb, pa, c, k1);
	memcpy(ma, pk, CRYPTO_PUBLICKEYBYTES);
	memcpy(ma+CRYPTO_PUBLICKEYBYTES, c, CRYPTO_CIPHERTEXTBYTES);
	*ma_byts = CRYPTO_PUBLICKEYBYTES + CRYPTO_CIPHERTEXTBYTES;

	memcpy(pa + CRYPTO_SECRETKEYBYTES, sk, CRYPTO_SECRETKEYBYTES);//pa=sk_a|sk
	memcpy(pa+ CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES, k1 , CRYPTO_BYTES);//pa=sk_a|sk|k1
	memcpy(pa + CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES+CRYPTO_BYTES, c, CRYPTO_CIPHERTEXTBYTES);//pa=sk_a|sk|k1|c
	memcpy(pa + CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES +CRYPTO_BYTES+ CRYPTO_CIPHERTEXTBYTES, pkb, CRYPTO_PUBLICKEYBYTES);//pa=sk_a|sk|k1|c|pk_b
	*pa_byts = CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES + CRYPTO_CIPHERTEXTBYTES + CRYPTO_BYTES+CRYPTO_PUBLICKEYBYTES;

	return 0;
}

int kex_send_b(unsigned char * pka, unsigned long long pka_byts, unsigned char * ma, unsigned long long ma_byts, unsigned char * pb, unsigned long long * pb_byts, unsigned char * mb, unsigned long long * mb_byts, unsigned char * ss, unsigned long long * ss_byts) {

	unsigned char ma1[CRYPTO_PUBLICKEYBYTES],pkb[CRYPTO_PUBLICKEYBYTES];
	memcpy(ma1, ma, CRYPTO_PUBLICKEYBYTES);
	memcpy(pkb, pb + SK_LEN, CRYPTO_PUBLICKEYBYTES);
	
	ake_bob_receive(pkb, pb, pka, ma1, ma + CRYPTO_PUBLICKEYBYTES, mb, ss);

	*ss_byts = CRYPTO_BYTES;
	*mb_byts = CRYPTO_CIPHERTEXTBYTES+ CRYPTO_CIPHERTEXTBYTES;
	
	return 0;
}

int kex_resp_a(unsigned char * mb, unsigned long long mb_byts, unsigned char * pa, unsigned long long * pa_byts, unsigned char * ma, unsigned long long * ma_byts, unsigned char * ss, unsigned long long * ss_byts) {
	
	//pa=sk_a|sk|k1|c|pk_b
	unsigned char pk_b[CRYPTO_PUBLICKEYBYTES];
	memcpy(pk_b, pa+CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES + CRYPTO_BYTES+CRYPTO_CIPHERTEXTBYTES, CRYPTO_PUBLICKEYBYTES);
	
	ake_alice_receive(pa + SK_LEN, pa, pk_b, pa + CRYPTO_SECRETKEYBYTES+SK_LEN, pa+CRYPTO_SECRETKEYBYTES, pa + CRYPTO_SECRETKEYBYTES+ CRYPTO_SECRETKEYBYTES +CRYPTO_BYTES, mb, pa + CRYPTO_SECRETKEYBYTES+ CRYPTO_SECRETKEYBYTES, ss);

	*ma_byts = 0;
	*ss_byts = CRYPTO_BYTES;
	return 0;

}


